package com.care.client.passport;

import com.google.common.cache.Cache;
import com.google.common.cache.CacheBuilder;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;

@Slf4j
@Service
public class PassportService {

    /*@Resource
    private RedisUtil redisUtil;
    @Resource
    private WxPassportService wxPassportService;
    @Resource
    private MemberOpenService memberOpenService;

    private final Cache<Long, String> timeoutCache = CacheBuilder.newBuilder().expireAfterWrite(10, TimeUnit.SECONDS).build();

    public ResultData login(MemberInitParams params) {
        CheckUtils.valueIsNull(params, "platform");

        if ("wx".equalsIgnoreCase(params.getLoginType())) {
            CheckUtils.valueIsNull(params, "code");
        } else if ("pwd".equalsIgnoreCase(params.getLoginType())) {
            CheckUtils.valueIsNull(params, "phone");
            CheckUtils.valueIsNull(params, "password");
        }
        ResultData result;
        switch (params.getPlatform()) {
            case WX:
                result = wxPassportService.login(params);
                break;
            default:
                throw BaseException.newException(PassportException.APP_NOT_SUPPORT, "platform[{0}] not support", params.getPlatform());
        }
        return result;
    }

    public void logout(String token) {
        CheckUtils.notNull(token, "token");
        MemberInfoVO open = (MemberInfoVO) redisUtil.hget(RedisKeyConstant.LOGIN_INFO, token);
        if (open != null) {
            redisUtil.hset(RedisKeyConstant.LOGIN_INFO, token, null);
        }
    }

    public MemberInfoVO checkToken(String token) {
        CheckUtils.notNull(token, "token");
        if (!redisUtil.hHasKey(RedisKeyConstant.LOGIN_INFO, token)) {
            throw BaseException.newException(PassportException.INVALID_TOKEN, "TOKEN WAS WRONG :[{0}]", token);
        }
        return (MemberInfoVO) redisUtil.hget(RedisKeyConstant.LOGIN_INFO, token);
    }

    public boolean notMatchMemberField(String token) {
        CheckUtils.notNull(token, "token");
        if (!redisUtil.hHasKey(RedisKeyConstant.LOGIN_INFO, token)) {
            throw BaseException.newException(PassportException.INVALID_TOKEN, "TOKEN WAS WRONG :[{0}]", token);
        }
        MemberInfoVO oldMemberInfoVO = (MemberInfoVO) redisUtil.hget(RedisKeyConstant.LOGIN_INFO, token);
        try {
            String newKey = timeoutCache.get(oldMemberInfoVO.getId(), () -> {
                MemberOpenDO dbMemberOpenDO = memberOpenService.get(oldMemberInfoVO.getId());
                StringBuffer sb = new StringBuffer();
                if (dbMemberOpenDO != null && dbMemberOpenDO.getMember() != null) {
                    sb.append("isReadVip").append(dbMemberOpenDO.getMember().getIsReadVip());
                    sb.append("isCourseVip").append(dbMemberOpenDO.getMember().getIsCourseVip());
                    sb.append("readVipExpired").append(dbMemberOpenDO.getMember().getReadVipExpired());
                    sb.append("courseVipExpired").append(dbMemberOpenDO.getMember().getCourseVipExpired());
                    sb.append("deposited").append(dbMemberOpenDO.getMember().getDeposited());
                }
                return sb.toString();
            });
            StringBuffer oldSb = new StringBuffer();
            oldSb.append("isReadVip").append(oldMemberInfoVO.getIsReadVip());
            oldSb.append("isCourseVip").append(oldMemberInfoVO.getIsCourseVip());
            oldSb.append("readVipExpired").append(oldMemberInfoVO.getReadVipExpired());
            oldSb.append("courseVipExpired").append(oldMemberInfoVO.getCourseVipExpired());
            oldSb.append("deposited").append(oldMemberInfoVO.getDeposited());
            return !newKey.equalsIgnoreCase(oldSb.toString());
        } catch (ExecutionException e) {
            e.printStackTrace();
        }
        return false;
    }*/
}
